﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint.StsAdmin;
using System.Collections.Specialized;
using Microsoft.SharePoint;
using System.IO;
using Microsoft.SharePoint.Publishing;
using Microsoft.SharePoint.Administration;

namespace Macaw.Moss2007.XmlSitemapSolution2
{
    public class SetXmlSitemapStsAdmExtension : ISPStsadmCommand
    {
        #region ISPStsadmCommand Members

        string ISPStsadmCommand.GetHelpMessage(string command)
        {
            StringBuilder message = new StringBuilder();
            message.Append("-url <site> [-disable] [-enable] [-host <hostname url>]");
            return message.ToString();
        }

        int ISPStsadmCommand.Run(string command, StringDictionary keyValues, out string output)
        {
            if (!keyValues.ContainsKey("url"))
            {
                output = "The \"url\" parameter was not specified.";
                return -1;
            }

            try
            {
                String url = keyValues["url"];

                using (SPSite site = new SPSite(url))
                {
                    if (keyValues.ContainsKey("disable"))
                    {
                        site.RootWeb.Properties[ManageXmlSitemap.XMLSITEMAPENABLED] = bool.FalseString;
                    }

                    if (keyValues.ContainsKey("enable"))
                    {
                        site.RootWeb.Properties[ManageXmlSitemap.XMLSITEMAPENABLED] = bool.TrueString;
                    }

                    if (keyValues.ContainsKey("host"))
                    {
                        site.RootWeb.Properties[ManageXmlSitemap.XMLSITEMAPURL] = keyValues["host"];
                    }

                    site.RootWeb.Properties.Update();
                }
            }
            catch (Exception ex)
            {
                output = "Error!\r\n" + ex.ToString();
                return -1;
            }
            output = "Done.";
            return 0;
        }

        #endregion
    }
}
