<%@ Control Language="C#" Debug="true" %>
<%@ Assembly Name="Microsoft.SharePoint, Version=12.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Register TagPrefix="SharePoint" Assembly="Microsoft.SharePoint, Version=12.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" Namespace="Microsoft.SharePoint.WebControls" %>
<%@ Register Assembly="Microsoft.SharePoint, Version=12.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" Namespace="Microsoft.SharePoint.WebControls" TagPrefix="cc1" %>
<SharePoint:RenderingTemplate ID="MacawMastWss3TemplatesMultiLevelSelectControl" runat="server">
  <Template>
  <script language="javascript" type="text/javascript">
    function OnTreeClick(evt) 
    { 
        var src = window.event != window.undefined ? window.event.srcElement : evt.target; 
        var isChkBoxClick = (src.tagName.toLowerCase() == "input" && src.type == "checkbox"); 
        if(isChkBoxClick) 
        {     
            var parentTable = GetParentByTagName("table", src);
            var nxtSibling = parentTable.nextSibling;     
            
            //check if nxt sibling is not null & is an element node      
            if(nxtSibling && nxtSibling.nodeType == 1)     
            {
                if (nxtSibling.tagName.toLowerCase() == "div") //if node has children         
                {             
                    //check or uncheck children at all levels             
                    CheckUncheckChildren(parentTable.nextSibling, src.checked);         
                }     
            } 
         }
     } 
      
     
      function CheckUncheckChildren(childContainer, check)
      { 
        var childChkBoxes = childContainer.getElementsByTagName("input");      
        var childChkBoxCount = childChkBoxes.length; 
        for(var i=0;i<childChkBoxCount;i++) 
        {
            if (check) 
            {
                childChkBoxes[i].checked = false;
            }
            childChkBoxes[i].disabled = check;
        }
      }
      
      function CheckUncheckParents(srcChild, check)
      { 
        var parentDiv = GetParentByTagName("div", srcChild); 
        var parentNodeTable = parentDiv.previousSibling; 
        if(parentNodeTable) 
        {     
            var checkUncheckSwitch;     
            if(check) //checkbox checked     
            {         
                var isAllSiblingsChecked = AreAllSiblingsChecked(srcChild);         
                if(isAllSiblingsChecked)                 
                    checkUncheckSwitch = true;         
                else                 
                    return; //do not need to check parent if any(one or more) child not checked     
            } else //checkbox unchecked     
            {         
                checkUncheckSwitch = false;     
            }        
            
            var inpElemsInParentTable = parentNodeTable.getElementsByTagName("input");     
            if(inpElemsInParentTable.length > 0)     
            {         
                var parentNodeChkBox = inpElemsInParentTable[0];         
                parentNodeChkBox.checked = checkUncheckSwitch;         
                //do the same recursively        
                CheckUncheckParents(parentNodeChkBox, checkUncheckSwitch);     
            } 
         }
      }
      function AreAllSiblingsChecked(chkBox)
      { 
        var parentDiv = GetParentByTagName("div", chkBox); 
        var childCount = parentDiv.childNodes.length; 
        for(var i=0;i<childCount;i++) 
        {     
            if(parentDiv.childNodes[i].nodeType == 1)     
            {         //check if the child node is an element node         
                if(parentDiv.childNodes[i].tagName.toLowerCase() == "table")         
                {             
                    var prevChkBox = parentDiv.childNodes[i].getElementsByTagName("input")[0];
                    //if any of sibling nodes are not checked, return false
                    if (!prevChkBox.checked) 
                    {
                        return false;
                    }
                }
            }
        }
        return true;
    }
    
    //utility function to get the container of an element by tagname
      function GetParentByTagName(parentTagName, childElementObj)
      { 
        var parent = childElementObj.parentNode; 
        while(parent.tagName.toLowerCase() != parentTagName.toLowerCase())     
        {         
            parent = parent.parentNode;     
        } 
        return parent;
    }

    function Update(id) 
    {
        var TV = document.getElementById(id);
        var CBS = TV.getElementsByTagName("input");
        for (var i = 0; i < CBS.length; i++) {
            var CB = CBS[i];
            if (CB.checked) {
                var parentTable = GetParentByTagName("table", CB);
                var nxtSibling = parentTable.nextSibling;

                //check if nxt sibling is not null & is an element node      
                if (nxtSibling && nxtSibling.nodeType == 1) {
                    if (nxtSibling.tagName.toLowerCase() == "div") //if node has children         
                    {
                        //check or uncheck children at all levels             
                        CheckUncheckChildren(parentTable.nextSibling, CB.checked);
                    }
                }
            } 
        }       
    }
  </script>
      <asp:TreeView ID="TreeView1" runat="server" ShowCheckBoxes="All" ShowLines="True" onclick="OnTreeClick(event)" ShowExpandCollapse="true" PopulateNodesFromClient="true" EnableClientScript="true">
      </asp:TreeView>
  </Template>
</SharePoint:RenderingTemplate>
