﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;
using System.Web.UI.WebControls;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint.Utilities;

namespace DeadLinkChecker
{
    public class CheckForDeadLinks : Microsoft.SharePoint.WebControls.LayoutsPageBase
    {
        protected HyperLink hlBrokenLinks;

        const string DEADLINKCHECKER_JOB_NAME = "DeadLinkChecker";

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        protected void btnCheck_OnClick(object sender, EventArgs e)
        {
            DeadLinkCheckerJobDefinition checkjob = null;
            // make sure the job isn't already registered
            foreach (SPJobDefinition job in SPContext.Current.Site.WebApplication.JobDefinitions)
            {
                if (job.Name == DEADLINKCHECKER_JOB_NAME)
                {
                    checkjob = (DeadLinkCheckerJobDefinition)job;
                }
            }

            if (checkjob != null)
            {
                using (SPLongOperation operation = new SPLongOperation(this.Page))
                {
                    operation.Begin();
                    try
                    {
                        checkjob.Execute(Site.ContentDatabase.Id);
                    }
                    finally
                    {

                        operation.End(Request.Url.ToString(), SPRedirectFlags.UseSource, this.Context, null);
                    }
                }
            }
        }

        protected override void CreateChildControls()
        {

            SPList bllist = SPContext.Current.Site.RootWeb.GetList("/Lists/BrokenLinks");
            hlBrokenLinks.NavigateUrl = bllist.DefaultViewUrl;
            base.CreateChildControls();
        }
    }
}
