using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace DeadLinkChecker
{
    public class DeadLinkCheckerJobFeatureReceiver : SPFeatureReceiver
    {

        const string DEADLINKCHECKER_JOB_NAME = "DeadLinkChecker";

        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            SPWebApplication webapp = properties.Feature.Parent as SPWebApplication;

            // make sure the job isn't already registered
            foreach (SPJobDefinition job in webapp.JobDefinitions)
            {
                if (job.Name == DEADLINKCHECKER_JOB_NAME)
                    job.Delete();
            }


            // install the job
            DeadLinkCheckerJobDefinition deadlinkcheckerJob = new DeadLinkCheckerJobDefinition(DEADLINKCHECKER_JOB_NAME, webapp);

            SPMinuteSchedule schedule = new SPMinuteSchedule();
            schedule.BeginSecond = 0;
            schedule.EndSecond = 59;
            schedule.Interval = 5;
            deadlinkcheckerJob.Schedule = schedule;

            deadlinkcheckerJob.Update();
        }

        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
            SPWebApplication webapp = properties.Feature.Parent as SPWebApplication;

            // delete the job
            foreach (SPJobDefinition job in webapp.JobDefinitions)
            {
                if (job.Name == DEADLINKCHECKER_JOB_NAME)
                    job.Delete();
            }

        }

        public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        {
            
        }

        public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        {
            
        }
    }
}
